//---------------------------------------------------------------------------
// testing Thread Priority
//
// Delphi Source  by Tom Nuydens <tom@delphi3d.net>
// http://www.delphi3d.net/download/threaddemos.zip
// Article : http://www.delphi3d.net/articles/viewarticle.php?article=threads.htm
//
// BCB rewrite and modify by dllee <dllee@edirect168.com>
//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "testPriorityUnit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
int SleepTime=50;
TRaceThread *Idle,*Lowest,*Lower,*Normal,*Higher,*Highest,*TimeCritical;
//---------------------------------------------------------------------------
__fastcall TRaceThread::TRaceThread(bool susp, TProgressBar *bar,
  TLabel *label) : TThread(susp)
{
  FPBar=bar;
  FPLabel=label;
  FTotalCount=0;
}
void __fastcall TRaceThread::Execute()
{
  while(!Terminated)
  {
    FTotalCount++;
    Synchronize(Step);
    Sleep(SleepTime); // n CPU 100%
  }
}
void __fastcall TRaceThread::Step()
{
  FPBar->Position = FPBar->Position + 1;
  if(FPBar->Position == FPBar->Max)
  {
    FPBar->Position = FPBar->Min;
    // PForm->ResetBars; // m
  }
  FPLabel->Caption=FTotalCount;
}
void __fastcall TRaceThread::ResetData()
{
  Synchronize(DoReset);
}
void __fastcall TRaceThread::DoReset()
{
  FTotalCount=0;
  FPBar->Position = FPBar->Min;
  FPLabel->Caption=FTotalCount;
}

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{
  Idle = new TRaceThread(true, ProgressBar1, Label1);
  Idle->Priority = tpIdle;
  Lowest = new TRaceThread(true, ProgressBar2, Label2);
  Lowest->Priority = tpLowest;
  Lower = new TRaceThread(true, ProgressBar3, Label3);
  Lower->Priority = tpLower;
  Normal = new TRaceThread(true, ProgressBar4, Label4);
  Normal->Priority = tpNormal;
  Higher = new TRaceThread(true, ProgressBar5, Label5);
  Higher->Priority = tpHigher;
  Highest = new TRaceThread(true, ProgressBar6, Label6);
  Highest->Priority = tpHighest;
  TimeCritical = new TRaceThread(true, ProgressBar7, Label7);
  TimeCritical->Priority = tpTimeCritical;
  Button1Click(Button1);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
  Idle->Suspend();
  Lowest->Suspend();
  Lower->Suspend();
  Normal->Suspend();
  Higher->Suspend();
  Highest->Suspend();
  TimeCritical->Suspend();

  delete Idle;
  delete Lowest;
  delete Lower;
  delete Normal;
  delete Higher;
  delete Highest;
  delete TimeCritical;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox1Click(TObject *Sender)
{
  if(CheckBox1->Checked) Idle->Resume();
  else                   Idle->Suspend();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox2Click(TObject *Sender)
{
  if(CheckBox2->Checked) Lowest->Resume();
  else                   Lowest->Suspend();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox3Click(TObject *Sender)
{
  if(CheckBox3->Checked) Lower->Resume();
  else                   Lower->Suspend();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox4Click(TObject *Sender)
{
  if(CheckBox4->Checked) Normal->Resume();
  else                   Normal->Suspend();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox5Click(TObject *Sender)
{
  if(CheckBox5->Checked) Higher->Resume();
  else                   Higher->Suspend();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox6Click(TObject *Sender)
{
  if(CheckBox6->Checked) Highest->Resume();
  else                   Highest->Suspend();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox7Click(TObject *Sender)
{
  if(CheckBox7->Checked) TimeCritical->Resume();
  else                   TimeCritical->Suspend();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
  int NewSleepTime=Edit1->Text.ToIntDef(1);
  if(NewSleepTime<=0) NewSleepTime=0;
  if(NewSleepTime==0) // FקKAҥHbɡAj Normal 
  {
    CheckBox5->Checked=false;
    CheckBox6->Checked=false;
    CheckBox7->Checked=false;
    CheckBox5->Enabled=false;
    CheckBox6->Enabled=false;
    CheckBox7->Enabled=false;
  }
  else
  {
    CheckBox5->Enabled=true;
    CheckBox6->Enabled=true;
    CheckBox7->Enabled=true;
  }
  SleepTime=NewSleepTime;
  Edit1->Text=SleepTime;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
  CheckBox1->Checked=true;
  CheckBox2->Checked=true;
  CheckBox3->Checked=true;
  CheckBox4->Checked=true;
  CheckBox5->Checked=true;
  CheckBox6->Checked=true;
  CheckBox7->Checked=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{
  CheckBox1->Checked=false;
  CheckBox2->Checked=false;
  CheckBox3->Checked=false;
  CheckBox4->Checked=false;
  CheckBox5->Checked=false;
  CheckBox6->Checked=false;
  CheckBox7->Checked=false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button4Click(TObject *Sender)
{
  Idle->ResetData();
  Lowest->ResetData();
  Lower->ResetData();
  Normal->ResetData();
  Higher->ResetData();
  Highest->ResetData();
  TimeCritical->ResetData();
}
//---------------------------------------------------------------------------
